﻿(function (window, undefined) {

    var version = "1.0.0";
    var devicetype = "";
    var postTimes = 0;
    var iosGetTimes = 0;
    var apiUrlPre = "api35";
    var config = {
        sitelogic: 'http://msitelogic.aoyou.com/api/',
        searchlogic: 'http://msearchlogic.aoyou.com/',
        productlogic: 'http://mproductlogic.aoyou.com/api/',
        memberlogic: 'http://mmemberlogic.aoyou.com/api/',
        bookinglogic: 'http://mbookinglogic.aoyou.com/api/',
        paylogic: 'http://mpaylogic.aoyou.com/api/',
        siteurl: 'http://m.aoyou.com/'
    };



    api = function (selector, context) {
        return api.prototype.init();
    };


    api = api.prototype = {

        version: version,

        init: function () {
            return this;
        },

        config: config,

        __callback__: new Array(),

        __iosCallback__: new Array(),

        getQueryString: function (key) {
            var reg = new RegExp("(^|&)" + key + "=([^&]*)(&|$)");
            var r = window.location.search.substr(1).match(reg);
            if (r != null) return unescape(r[2]); return null;
        },

        getCookie: function (key) {
            if (api.getQueryString('devicetype') == 'ios') {
                ios.getCookie(key);
            }
            else if (api.getQueryString('devicetype') == 'android') {
                return android.getCookie(key);
            }
            else {

                var bikky = document.cookie;
                key += "=";
                var i = 0;
                while (i < bikky.length) {
                    var offset = i + key.length;
                    if (bikky.substring(i, offset) == key) {
                        var endstr = bikky.indexOf(";", offset);
                        if (endstr == -1) endstr = bikky.length;
                        return unescape(bikky.substring(offset, endstr));
                    }
                    i = bikky.indexOf(" ", i) + 1;
                    if (i == 0) break;
                }
                return null;
            }
        },

        setCookie: function (key, value, timeout) {

            if (!timeout || typeof (timeout) == 'undefined') {
                timeout = 0;
            }
            if (devicetype == 'ios') {

                ios.setCookie(key, value, timeout);
            }
            else if (devicetype == 'android') {
                android.setCookie(key, value, timeout);
            }
            else {
                if (timeout == 0) {
                    document.cookie = key + "=" + value + ";domain=.aoyou.com;path=/";
                }
                else {
                    var exp = new Date();
                    exp.setTime(exp.getTime() + timeout * 1000);
                    document.cookie = key + "=" + value + ";expires=" + exp.toGMTString() + ";domain=.aoyou.com;path=/";
                }
            }
        },

        removeCookie: function (key) {
            if (devicetype == 'ios') {
                ios.removeCookie(key);
            }
            else if (devicetype == 'android') {
                android.removeCookie(key);
            }
            else {
                var exp = new Date();
                exp.setTime(exp.getTime() - 3600 * 24);
                var value = '';
                document.cookie = key + "=" + value + ";expires=" + exp.toGMTString() + ";domain=.aoyou.com;path=/";
            }
        },

        getLocalStorage: function (key) {
            return localStorage.getItem(key);
        },

        setLocalStorage: function (key, value) {
            try {
                localStorage.removeItem(key);
                localStorage.setItem(key, value);
            }
            catch (_) {
                alert("该功能无法使用，请关闭浏览器无痕模式（隐身模式）后重试");
            }
        },
        //
        post: function ($http, $scope, path, controller, action, param, useCache, callback, needLogin) {


            if (devicetype == 'ios') {
                ios.post($http, $scope, path, controller, action, param, useCache, callback, needLogin);
            }
            else if (devicetype == 'android') {
                android.post($http, $scope, path, controller, action, param, useCache, callback, needLogin);
            }
            else {
                api.loading();
                if (!needLogin || typeof (needLogin) == 'undefined') {

                }
                if (param.toLowerCase().indexOf("memberid") > 0 && !api.checkLogin()) {

                    callback({ ErrorCode: 200 });
                }
                else {
                    postTimes++;
                    api.__callback__.push([postTimes, callback, $scope]);
                    var url = "/api/GetApiData";
                    var apiParam = {
                        path: path,
                        controller: controller,
                        action: action,
                        param: param,
                        useCache: useCache
                    };

                    $http.post(url, apiParam).success(function (data, status) {
                        api.endloading();
                        callback(data);

                    });
                }

            }
        },

        callback: function (index, data) {
            var formatData = {};
            if (data.ReturnCode == 0) {
                data.Data.__UpdateTime__ = new Date()
                formatData = {
                    ErrorCode: 200,
                    JsonResult: JSON.stringify(data.Data)
                };
            }
            else {

                formatData = {
                    ErrorCode: data.ReturnCode,
                    ErrorMsg: data.Message
                };
            }
            var currentArray = new Array();
            for (var i = 0; i < api.__callback__.length; i++) {
                if (api.__callback__[i][0] == index) {
                    currentArray = api.__callback__[i];
                    api.__callback__.splice(i, 1);
                    break;
                }
            }
            if (currentArray.length > 2) {
                currentArray[2].$apply(function () {
                    currentArray[1](formatData);
                });
            }
            api.endloading();
        },

        iosCallback: function (action, key, value, index, callbackData) {
            ios.callback(action, key, value, index, callbackData);
        },

        getMemberId: function () {

            if (devicetype == 'ios') {
                return -1;
            }
            else if (devicetype == 'android') {
                return -1;
            }
            else {
                var memberid = api.getCookie('memberid');
                if (!memberid || typeof (memberid) == 'undefined' || memberid.length < 5) {
                    location.href = "http://mpass.aoyou.com?from=" + location.href + "&forward=" + location.href;
                    return null;
                }
                else {
                    return memberid;
                }
            }
        },


        checkLogin: function () {
            if (devicetype == 'ios') {
                ios.checkLogin();
            }
            else if (devicetype == 'android') {
                android.checkLogin();
            }
            else {
                var memberid = api.getCookie("memberid");
                if (!memberid || typeof (memberid) == 'undefined' || memberid.length < 5) {
                    location.href = "http://mpass.aoyou.com?from=" + location.href + "&forward=" + location.href;
                    return false;
                }
                else {
                    return true;
                }
            }
        },

        logout: function () {
            if (devicetype == 'ios') {
                ios.logout();
            }
            else if (devicetype == 'android') {
                android.logout();
            }
            else {
                api.removeCookie('memberid');
                location.href = 'http://mpass.aoyou.com';
            }
        },

        loading: function () {
            var loading = document.createElement("div");
            loading.className = "loading";
            loading.id = "loading";
            var loader = document.createElement("div");
            loader.className = "loader";
            for (var i = 0; i < 4; i++) {
                var span = document.createElement("span");
                loader.appendChild(span);
            }
            loading.appendChild(loader);
            document.body.appendChild(loading);
        },

        endloading: function () {
            var loading = document.getElementById('loading');
            document.body.removeChild(loading);
        },

        invoke: function () {
            if (devicetype == 'ios') {
                ios.invoke();
            }
        }
    };


    devicetype = api.getQueryString("devicetype");


    var android = {

        getCookie: function (key) {
            if (key == "memberid") {
                return window.cookie.getMemberID();
            }
            else {
                return window.cookie.getCookie(key)
            }
        },
        setCookie: function (key, value, timeout) {

            if (!timeout || typeof (timeout) == 'undefined') {
                timeout = 0;
            }

            if (key == 'memberid') {
                window.cookie.setMemberID(value);
            }
            else {
                window.cookie.setCookie(key, value, timeout);
            }

        },

        removeCookie: function (key) {

            try {
                window.cookie.removeCookie(key);
            }
            catch (e) {
                alert(e.message);
            }

        },
        checkLogin: function () {
            var memberid = android.getCookie("memberid");
            if (!memberid || typeof (memberid) == 'undefined' || memberid.length < 5) {

                var loginParam = JSON.stringify({
                    from: location.href,
                    forward: location.href
                });
                window.action.exec('login', loginParam);
                return false;
            }
            else {
                return true;
            }
        },
        logout: function () {
            android.removeCookie('memberid');
            var loginParam = JSON.stringify({
                from: location.href,
                forward: location.href
            });
            try {
                window.action.exec('login', loginParam);
            }
            catch (e) {
                alert(e.message);
            }
        },

        post: function ($http, $scope, path, controller, action, param, useCache, callback, needLogin) {
            api.loading();
            postTimes++;
            api.__callback__.push([postTimes, callback, $scope]);

            var memberid = android.getCookie("memberid");
            if (!needLogin && typeof (needLogin) == 'undefined') {
                if (param.toLowerCase().indexOf("memberid") > -1 && memberid == '') {
                    needLogin = true;
                }
                else {
                    needLogin = false;
                }

            }
            else if (needLogin == false) {
                needLogin = false;
            }
            if (needLogin == true) {
                var loginParam = JSON.stringify({
                    from: location.href,
                    forward: location.href
                });
                try {
                    window.action.exec('login', loginParam);
                    callback({ ErrorCode: -2, ErrorMsg: '未登录' });
                }
                catch (e) {
                    alert('调用Android登录失败，' + e.message);
                }

            }
            else {

                var isUseCache = useCache ? 1 : 0;

                var url = apiUrlPre + '/' + controller + '/' + action;
                try {
                    window.action.invoke(postTimes, url, param, isUseCache);

                }
                catch (e) {
                    alert(e.message);
                }

            }
        },

    };

    var ios = {

        invokeApp: function (action, param) {


            var iframe;
            iframe = document.createElement("iframe");
            iframe.setAttribute("src", action + "://" + param);
            iframe.setAttribute("style", "display:none;");
            iframe.setAttribute("height", "0px");
            iframe.setAttribute("width", "0px");
            iframe.setAttribute("frameborder", "0");
            document.body.appendChild(iframe);
            iframe.parentNode.removeChild(iframe);
            iframe = null;
        },


        callback: function (action, key, value, index) {
            var currentArray = new Array();
            for (var i = 0; i < api.__iosCallback__.length; i++) {
                if (api.__iosCallback__[i][0] == index) {
                    currentArray = api.__iosCallback__[i];
                    api.__iosCallback__.splice(i, 1);
                    break;
                }
            }

            if (currentArray.length > 3) {
                currentArray[3](value);
            }
        },
        //
        getCookie: function (key, index) {

            if (key == "memberid") {
                var param = JSON.stringify({
                    index: index
                });
                ios.invokeApp("cookie.getMemberID", param);
            }
            else {
                var param = JSON.stringify({
                    index: index,
                    key: key
                });

                ios.invokeApp("cookie.getCookie", param);
            }
        },
        setCookie: function (key, value, timeout) {

            if (!timeout || typeof (timeout) == 'undefined') {
                timeout = 0;
            }

            if (key == 'memberid') {
                var param = JSON.stringify({
                    value: value
                });
                ios.invokeApp("cookie.setMemberID", param);
            }
            else {
                var param = JSON.stringify({
                    key: key,
                    value: value,
                    timeout: timeout
                });
                ios.invokeApp("cookie.setCookie", param);
            }

        },

        removeCookie: function (key, index) {
            if (key == 'memberid') {
                var param = JSON.stringify({
                    index: index
                });
                ios.invokeApp("cookie.removeMemberID", index);

            }
            else {
                var param = JSON.stringify({
                    index: index,
                    key: key
                });
                ios.invokeApp("cookie.removeCookie", param);
            }

        },
        checkLogin: function (callback) {
            iosGetTimes++;
            api.__iosCallback__.push([iosGetTimes, 'getMemberID', 'memberid', function (memberid) {
                if (!memberid || typeof (memberid) == 'undefined' || memberid.length < 5) {
                    var loginParam = JSON.stringify({
                        action: 'login',
                        from: location.href,
                        forward: location.href
                    });
                    ios.invokeApp("action.exec", loginParam);
                }
                else {
                    callback();
                }
            }]);
            ios.getCookie('memberid', iosGetTimes);


        },
        logout: function () {
            iosGetTimes++;
            api.__iosCallback__.push([iosGetTimes, 'removeMemberID', 'memberid', function () {
                var loginParam = JSON.stringify({
                    action: 'login',
                    from: location.href,
                    forward: location.href
                });
                ios.invokeApp("action.exec", loginParam);
            }]);
            ios.removeCookie('memberid', iosGetTimes);
        },
        post: function ($http, $scope, path, controller, action, param, useCache, callback, needLogin) {


            api.loading();
            postTimes++;
            api.__callback__.push([postTimes, callback, $scope]);

            var url = apiUrlPre + '/' + controller + '/' + action;
            var isUseCache = 0;
            if (useCache) {
                isUseCache = 1;
            }
            else {
                isUseCache = 0;
            }
            var invokeParam = JSON.stringify({
                index: postTimes,
                url: url,
                param:"***"+encodeURI(param)+"***",
                usecache: isUseCache
            });

            ios.checkLogin(function () {
                ios.invokeApp("action.invoke",invokeParam);
            });

        }

    }
    window.api = api;

}(window));



